//*************************************************************************************
// 	: SQ7653_ADC.c
// 汾		: V1.0
// 		: ADC ʹú (ADCƳ)
// ע		: ADC غ㼯ڱӳ
//*************************************************************************************

#include "main.h"


//*********************************************************************
// 	: ADC_Init()
// 	: ADCʼ
// ע		: 
//*********************************************************************
void ADC_Init(){
//====== ADCܽųʼ (ѡAD תģźͨ)======
// SQ7653AIN0~AIN7 8ܽſʹ---------------------

/*
	//--- AIN0 ---//	
	P1CFGCR = 0x8F;                       // P1.0ΪAIN0
	 
*/

/*
	//--- AIN1 ---//	
	P1CFGCR = 0x9F;                       // P1.1ΪAIN1
*/

/*
	//--- AIN2 ---//	
	P1CFGCR = 0xAF;                       // P1.2ΪAIN2
	
*/
	
/*
	//--- AIN3 ---//	
	P1CFGCR = 0xBF;                       // P1.3ΪAIN3
	
*/


	//--- AIN4 ---//	 [ѡܽ]
	P1CFGCR = 0xCF;                       // P1.4ΪAIN4
	 


/*
	//--- AIN5 ---//	
	P1CFGCR = 0xDF;                       // P1.5ΪAIN5
	
*/	
	
/*
	//--- AIN6 ---//	
	P1CFGCR = 0xEF;                       // P1.6ΪAIN6
	
*/		

/*
	//--- AIN7 ---//	
	P1CFGCR = 0xFF;                       // P1.7ΪAIN7
	
*/	

// -------------------------------------------------------------
//====== 趨 ======
	PCKEN6_ADC   = 1;                     // 趨Χ·ʱADCĴ ADC peripheral clock enable
	ADCCR0_IRFEN = 0x01;                  // ʹVDDAοѹ
	
	ADCCKDIV = 0x04;                      // ADC clock = fsysclk/(2^4)
    ADCCR0_INTLV = 1;                     // ж趨ȫAINɨɲŷж
	
	ADCCR1_EVSEL = 0x00;                  // ¼趨ΪADCת
	
	//źͨɨ
	ADCSCAN0 = 0x10;                      // ADC ɨͨ:AIN4         
	//ADCSCAN1 = 0x00;                    
}

//*********************************************************************
// 	: ADC_Start()
// 	:  ADC
// ע		:
//*********************************************************************
void ADC_Start()
{
	ADCCR0_ADEN = 1;                      //  AD ת
}


//*********************************************************************
// 	: ADC_Stop()
// 	: ֹͣ ADC	
// ע		: 
//*********************************************************************
void ADC_Stop()
{
	ADCCR0_AMD  = 0;                      // תֹǿֹͣAD 
    ADCCR0_ADEN = 0;                      // ADCֹ    
}


//*********************************************************************
// 	: ADC_IntEnable()
// 	: ADCж
// ע		: 
//*********************************************************************
void ADC_IntEnable(){
	__ASM("DI");

	IER_ADC_IRQ = 1;                     // ADC ж
	ADCCR0_INTEN = 1;                    // ADC ж
	__ASM("EI");
}


//*********************************************************************
// 	: ADC_Disable()
// 	: ֹADCж
// ע		: 
//*********************************************************************
void ADC_Disable(){
	__ASM("DI");

	IER_ADC_IRQ = 0;                     // ADC жϽ
	ADCCR0_INTEN = 0;                    // ADC жϽֹ
	__ASM("EI");
}



//*********************************************************************
//    : ADC_Convert_Repeat()
//  : ִADCתظģʽתADCDRL  ADCDRH
// ע     :
//*********************************************************************
unsigned int ADC_Convert_Repeat(uchar SAIN)
{
    uchar i;
    ulong adc_data = 0;
    uint  ad_min   = 0, ad_max = 4096;
    BIT_LIST_16 ADC_READ;

//====== 趨 ======
	ADCCHSEL_CHSEL = SAIN;                  // ѡ AD תģźͨ

	ADCCR0_AMD = 0x03;                      // 趨ADCģʽ:
	while(!ADCSR_ADRDY);                    // ȴADCʼִADת=	
    ADCSR_ADRS = 1;                         // ʼ AD ת


    for( i=0; i<(ad_test_times+2); i++ )    // ظ18
    {
        while( !ADCSR_EOCF ){ CLR_WDT; }    // 1: AD תɣ 0: AD תǰת
        ADCSR_EOCF = 1;                     // ADCת		
        ADC_READ.byte[0] = ADCDRL;          // ȡ ADC ֵȶ Low Byte, ٶ High Byte
        ADC_READ.byte[1] = ADCDRH;          // ȡ ADC ֵȶ Low Byte, ٶ High Byte
        adc_data += ADC_READ.word;
        if( ADC_READ.word > ad_min ) ad_min = ADC_READ.word;
        if( ADC_READ.word < ad_max ) ad_max = ADC_READ.word;
    }
    ADCSR_ADRS = 0;                         // ֹͣ AD ת

    adc_data -= ad_max;                     // ȥֵ
    adc_data -= ad_min;                     // ȥСֵ
    
	adc_data /= ad_test_times;              // ƽ

	return (unsigned int)adc_data;
}

//*********************************************************************
// 	: ADC_Convert_Single()
// 	: ADC Single modeת
// ע		: 
//*********************************************************************
void ADC_Convert_Single(){

	ADCCR0_AMD = 0x01;                      // 趨ADCģʽ:
	while(!ADCSR_ADRDY);                    // ȴADC
	ADCSR_ADRS = 1;                         // ADCתʼ	
}

//*********************************************************************
// 	: ADC_ConvertDone()
// 	: ADCת
// ע		: 
//*********************************************************************
char ADC_ConvertDone(){
	if(ADCSR_EOCF){
		return 1;                           // ADCתɣش1
	}
	else{
		return 0;                           // ֮ADCתδɣش0
	}
}



//*********************************************************************
// 	: ADC_Read_Value()
// 	: ADCֵ
// ע		: chsel :ѡһAIN,趨£ 
// AIN0	       0x0
// AIN1	       0x1
// AIN2	       0x2
// AIN3	       0x3
// AIN4	       0x4
// AIN5	       0x5
// AIN6	       0x6
// AIN7	       0x7

//*********************************************************************
long ADC_Read_Value(unsigned char chsel){
	unsigned int adc_value = 0;
	
	ADCCHSEL = chsel;                       // ѡADCͨ
	
	adc_value |= ADCDRL;                    // ADCֵ,ȶLow Byte,ٶHigh Byte
	adc_value |= (unsigned int)ADCDRH<<8;
	return (long)adc_value;
}


//*********************************************************************
// 	: __interrupt ADC_IRQ()
// 	: ADC жӳ
// ע		:
//*********************************************************************
void __interrupt ADC_IRQ(void){
	__asm("NOP");                           // ָ
	LED1_out = ~LED1_out;                   // LED1 (LED1 (P0.0))

}

