//*************************************************************************************
// 	: SQ7653_startup_LVD_SWRST.c
// 汾		: V1.0
// 		: 
// ע		: 
//**************************************************************************************

/*
 * --------------------------------------------------------------------------
 *   HEADER INCLUDE DEFINITIONS
 * --------------------------------------------------------------------------
 */
#include <stdlib.h>
#include "SQ7653_SFR.h"


/*
 * --------------------------------------------------------------------------
 *   MACRO DEFINITIONS
 * --------------------------------------------------------------------------
 */
 
extern unsigned int  _BaseSP;				/*ѵָʼַһ㶨SRAMһַ*/
extern unsigned int  _RAM_Top;				/*SRAMĵһַ*/
extern unsigned int  _RAM_End;				/*SRAMһַ*/

extern unsigned char _TDataAddr[];			/* for tiny_data initialize, defined in link command file  */
extern unsigned char _TDataOrg[];			/* for tiny_data initialize, defined in link command file  */
extern unsigned int  _TDataSize;			/* for tiny_data initialize, defined in link command file  */
extern unsigned char _NDataAddr[];			/* for near_data initialize, defined in link command file  */
extern unsigned char _NDataOrg[];			/* for near_data initialize, defined in link command file  */
extern unsigned int  _NDataSize;			/* for near_data initialize, defined in link command file  */

/*
 * --------------------------------------------------------------------------
 *   FUNCTION DECLARATIONS
 * --------------------------------------------------------------------------
 */

/*#**************************************************************************#*/

/*
 ******************************************************************************
 * NAME				:STARTUP
 *-----------------------------------------------------------------------------
 * DESCRIPTION		:Startup routine
 * PARAMETER		:-
 *
 * RETURN VALUE		:-
 *
 ******************************************************************************
 */
void STARTUP( void )
{
	unsigned int VDD_Lower_DTVT_CNT;		  // VDDڼѹ֮(Cnt Vdd Lower Than Detect Voltage)
	unsigned int i,j;
	
	//CLKCR0 = 0x09;						  // for SQ7653A PLL48M divide by 2, For Engineer Sample. 
    CLKCR0 = 0x01;						      // for SQ7653A PLL24M divide by 1, For General.
	VDD_Lower_DTVT_CNT = 0;				  	  // VDDڼѹֵ֮Ϊ0
//=============================================================================
//  Set CLKCR0	2019-06/12 JH ADD
//=============================================================================
//  ============================================
//  ϵyrԴxCLKCR0_SCKSRC                                 
//  ============================================
	
	CLKCR0_SCKSEL = 0x01;			// fsck = 24MHz	 (PLL) //Default
//	CLKCR0_SCKSEL = 0x02;			// fsck = 32KHz	 (LIRC) Ȳمr
//	CLKCR0_SCKSEL = 0x03;			// fsck = 16MHz	 (HXTAL)ⲿٕr
//	CLKCR0_SCKSEL = 0x06;			// fsck = 32768Hz(LXTAL)ⲿٕr

//  ============================================
//  ϵyrxCLKCR0_SCKLF                                 
//  ============================================
//	CLKCR0_SCKLF = 0;				// LIRC  Ȳ [AO]
//	CLKCR0_SCKLF = 1;				// LXTAL ⲿ

//  ============================================
//  ϵyrAlOãCLKCR0_SCKPSC                                 
//  ============================================
//	CLKCR0_SCKPSC = 0x00;			// fsysclk= fsck/1 * PLL֧Ԯ˹
//	CLKCR0_SCKPSC = 0x01;			// fsysclk= fsck/2 [AO]
//	CLKCR0_SCKPSC = 0x02;			// fsysclk= fsck/4
//	CLKCR0_SCKPSC = 0x03;			// fsysclk= fsck/8
//	CLKCR0_SCKPSC = 0x04;			// fsysclk= fsck/16
//	CLKCR0_SCKPSC = 0x05;			// fsysclk= fsck/32
//	CLKCR0_SCKPSC = 0x06;			// fsysclk= fsck/64
//	CLKCR0_SCKPSC = 0x07;			// fsysclk= fsck/128
	
//=============================================================================
// memory mapping
//=============================================================================
	DMCFG  	 = 0x02; 						  // Code :0x8000~0xFFFF Map to Data: 0x8000~0xFFFF,
	//DMCFG  = 0x00;						  // Code :0x0000~0x7FFF Map to Data: 0x8000~0xFFFF
	
//=============================================================================
// Setting detection voltage (2.85 V  90mV)
//=============================================================================
	
	P0OE_P0 = 1;							  //P0.0 趨Ϊ 
	P0DO_P0 = 0;                              // LED1(P0.0)
	for(i=0;i<1500;i++){					  // ʱһʱ
		for(j=1500;j>0;j--);
	}
	P0DO_P0 = 1;							  // ʹLED1(P0.0)
	for(i=0;i<1500;i++){					  // ʱһʱ
		for(j=1500;j>0;j--);
	}

	
	LVDCR0_LVDCFG   = 0x03;					  // üѹΪ 2.85 V  90mV
	LVDCR1_LVDRSTEN = 1;                      // ⵽ LVD  0: Interrupt, 1: Reset.
	LVDCR0_LVDEN    = 1;                	  // LVD0
	
	
	while(1){	
		WDCDR = 0x4E;             	  		  // 룬Źʱ (ι)
		//if(LVDCR0_LVDF == 1 && IFR_LVD0_IRQ == 1){
	    if(LVDCR0_LVDF == 1 ){
			VDD_Lower_DTVT_CNT ++;			  // ⵽LVD0(VDD <  LVDCR0_LVDCFG 趨֮ѹ)"VDDڼѹ֮"+1
			if(VDD_Lower_DTVT_CNT >= 50){	
				break;						  // ⵽LVD0(VDD <  LVDCR0_LVDCFG 趨֮ѹ)(50+1)Σ뿪ˏhȦ
			}
		}
		else{
			VDD_Lower_DTVT_CNT = 0;		  	  // ⵽LVD0(VDD >= LVDCR0_LVDCFG 趨֮ѹ) "VDDڼѹ֮"0
		}
		
		if(LVDCR0_LVDF == 1){
			LVDCR0_LVDF = 1;             	  // ⵽LVD0LVD0Ϊ 0;
		}		
	}

	LVDCR0_LVDIEN	= 1;                	  // LVD0 Д
	IER_LVD0_IRQ 	= 1;                	  // LVD0 ж
	__ASM("EI");							  // жĴ



//=============================================================================
// initial Registers
//=============================================================================
	__WA = 0x00;
	__BC = 0x00;
	__DE = 0x00;
	__HL = 0x00;
	__IX = 0x00;
	__IY = 0x00;

//=============================================================================
// initial Setting
//=============================================================================	
	__asm("CLR (0x08).5");

//=============================================================================
// initialize stack pointer
//=============================================================================
	__asm(" LD SP,__BaseSP");	//initialize stack pointer

//=============================================================================
// clear status word
//=============================================================================
	__asm(" LD PSW,0x00");

//=============================================================================
// clear RAM
//=============================================================================
	__asm(" LD HL,__RAM_Top");
	__asm(" LD BC,__RAM_End - __RAM_Top");	
	__asm(" LD A,0x00");
	__asm("CLR_RAM:");
	__asm(" LD (HL),A");
	__asm(" INC HL");
	__asm(" DEC BC");
	__asm(" JRS F,CLR_RAM");		/* Clear the RAM */

//=============================================================================
// initialize of tiny_data section
//=============================================================================
	__asm("	LD	IX,__TDataOrg");
	__asm("	LD	IY,__TDataAddr");
	__asm("	LD	A,__TDataSize");
	__asm("	DEC	A");
	__asm("	J	T,non_t_data");
	__asm("move_t_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	A");
	__asm("	J	F,move_t_data");
	__asm("non_t_data:");

//=============================================================================
// initialize of near_data section
//=============================================================================
	__asm("	LD	IX,__NDataOrg");
	__asm("	LD	IY,__NDataAddr");
	__asm("	LD	WA,__NDataSize");
	__asm("	DEC	WA");
	__asm("	J	T,non_n_data");
	__asm("move_n_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	WA");
	__asm("	J	F,move_n_data");
	__asm("non_n_data:");


//=============================================================================
// jump to main
//=============================================================================
	main();
	for (;;) {
		;
	}
}

