//*************************************************************************************
// 	: SQ7653_PLL_System_Init.c
// 汾		: V1.0 2020/07/17A
// 		: PLL_System_Initʹú
// ע		: غ㼯ڱӳ
//**************************************************************************************

#include "main.h"

//*********************************************************************
// 	: PLL_System_Init()
// 	: PLLϵͳʱԴʼ
// ע		: 
// F_div_sel: PLL_24M	ϵͳƵʳ1  (24M/1  = 24MHz)
//			  PLL_12M	ϵͳƵʳ2  (24M/2  = 12MHz)
//            PLL_6M	ϵͳƵʳ4  (24M/4  = 6MHz)
//			  PLL_3M	ϵͳƵʳ8  (24M/8  = 3MHz)
//			  PLL_1_5M  ϵͳƵʳ16 (24M/16 = 1.5MHz = 1500KHz)
//			  PLL_750K  ϵͳƵʳ32 (24M/32 = 750kHz)
//			  PLL_375K  ϵͳƵʳ64 (24M/64 = 375kMHz)
//			  PLL_187_5K  ϵͳƵʳ128(24M/128 = 187.5kHz) 
//
// 		: ҪʹPLL 24MHzΪϵͳʱԴƵʹʾ:
//			  PLL_System_Init(PLL_12M);		  // (24M/2 = 12MHz) 
//*********************************************************************
void PLL_System_Init(unsigned char F_div_sel){

	PLLCR0_PLLEN  = 1;                     	  //  PLL
	while(PLLCR0_PLLRDY ==0);				  // ȴ PLL 
	PLL_Freq_Division(F_div_sel);			  // PLLϵͳʱӳƵѡ
    CLKCR0_SCKSEL = 1;                        // ʱԴлPLL
	
	while(CLKST_SCKSRC == 0x01 && CLKST_SCKRDY == 0);// ȴ ϵͳʱPLLѾ
}


//*********************************************************************
// 	: PLL_Freq_Division()
// 	: PLLϵͳʱӳƵѡ
// ע		: 
//*********************************************************************
void PLL_Freq_Division(unsigned char F_div_sel){


	CLKCR0_SCKPSC = F_div_sel;                // ϵͳƵʳƵѡ
  

}

