//*************************************************************************************
// 	: SQ7653_TMRA0_PPG.h
// 汾		: V1.0 2020/07/17A
// 		: TMRA0_PPG ͷļ 
// ע		:        
//**************************************************************************************
#ifndef _SQ7653_TMRA0_PPG_H__
#define _SQ7653_TMRA0_PPG_H__

/* ---------------------- extern ȫֱ ------------------------- */
extern unsigned char TMRA00_Int_Flag;	  	       // TMRA00жϷ
extern unsigned char TMRA01_Int_Flag;	  	       // TMRA01жϷ
extern unsigned int  period;
extern unsigned int  duty;

/* ---------------------- Զ ------------------------------ */
#define   enable    			  0x01		       // (Enable) 
#define   disable  				  0x00		       // ֹ(Disable)

//For t_mod_sel------
#define   set_8bit    		      0x00		       // 趨Ϊ 8λģʽ
#define   ppg_andlogic            0x01		 	   // 趨Ϊ ʱ01 PPG߼ANDģʽ 
#define   set_16bit  			  0x02		       // 趨Ϊ 16λģʽ
//#define pre_scale   			  0x04		       // 趨Ϊ ԤȷƵģʽ
//#define complementary   		  0x05		       // 趨Ϊ ģʽ

//For op_mod_sel------
//#define timer    				  0x00		       // 趨Ϊ ʱģʽ
//#define event  		          0x01		       // 趨Ϊ ¼ģʽ 
//#define capture  			      0x03	  	       // 趨Ϊ ģʽ
//#define pwm                     0x04		       // 趨Ϊ PWMģʽ
//#define pulse_measure           0x05		       // 趨Ϊ ģʽ
#define ppg					      0x06		       // 趨Ϊ ɳPPGģʽ

// -----------------------------------------------------------------------
void TMRA00_8bit_PPG_Init();				       // TMRA00 8λɱPPG ģʽʼ
void TMRA01_8bit_PPG_Init();				       // TMRA01 8λɱPPG ģʽʼ
void TMRA0_16bit_PPG_Init();					   // TMRA0 16λɱPPG ģʽʼ
void TMRA00_TMRA01_8bit_PPG_Logic_AND_Init();	   // 8λʱ0ʱ1 PPG߼ANDģʽʼ

void TMRA00_IntEnable();						   // TMRA00ж (Enable)
void TMRA01_IntEnable();						   // TMRA01ж (Enable)
void TMRA00_IntDisable();						   // TMRA00жϽֹ (Disable)
void TMRA01_IntDisable();						   // TMRA01жϽֹ (Disable)

void TMRA00_SetPeriod(unsigned int period);      // 趨TMRA00 ڣѭʱ
void TMRA01_SetPeriod(unsigned int period);      // 趨TMRA01 ڣѭʱ
void TMRA0_16bit_SetPeriod(unsigned int period); // 趨16λTMRA00(8λ)+TMRA01(8λ) ڣѭʱ

void TMRA00_SetDuty(unsigned int duty);          // 趨TMRA00 ռձ
void TMRA01_SetDuty(unsigned int duty);		   // 趨TMRA01 ռձ
void TMRA0_16bit_SetDuty(unsigned int duty);	   // 趨16λTMRA00(8λ)+TMRA01(8λ) ռձ

void TMRA00_Start();							   // TMRA00ɱPPG 
void TMRA01_Start();							   // TMRA01ɱPPG 
void TMRA0_16bit_Start();						   // 16λTMRA00(8λ)+TMRA01(8λ) PPG 
void TMRA00_TMRA01_8bit_PPG_Logic_AND_Start();	   // 8λʱ0ʱ1 PPG߼AND

void TMRA00_Stop();								   // ֹͣTMRA00 PPG 
void TMRA01_Stop();								   // ֹͣTMRA01 PPG 
void TMRA0_16bit_Stop();						   // ֹͣ16λTMRA00(8λ)+TMRA01(8λ) PPG 
void TMRA00_TMRA01_8bit_PPG_Logic_AND_Stop();	   // ֹͣ8λʱ0ʱ1 PPG߼AND

void __interrupt TMRA00_IRQ(void);				   // TMRA00жӳ
void __interrupt TMRA01_IRQ(void);				   // TMRA01жӳ


#endif


