//*************************************************************************************
// 	: SQ7653_TMRA0_Timer.h
// 汾		: V1.0 2020/07/17A
// 		: TMRA0_Timer ͷļ 
// ע		:        
//**************************************************************************************
#ifndef _SQ7653_TMRA0_TIMER_H__
#define _SQ7653_TMRA0_TIMER_H__

/* ---------------------- extern ȫֱ ------------------------- */
extern unsigned char TMRA00_Int_Flag;	  	     // TMRA00жϷ
extern unsigned char TMRA01_Int_Flag;	  	     // TMRA01жϷ

/* ---------------------- Զ ------------------------------ */
#define   enable    			  0x01		     // (Enable) 
#define   disable  				  0x00		     // ֹ(Disable)

//For t_mod_sel------
#define   set_8bit    			  0x00		     // 趨Ϊ 8λģʽ
//#define ppg_andlogic            0x01		 	 // 趨Ϊ ʱ01 PPG߼ANDģʽ 
#define   set_16bit  			  0x02		     // 趨Ϊ 16λģʽ
//#define pre_scale   			  0x04		     // 趨Ϊ ԤȷƵģʽ
//#define complementary   		  0x05		     // 趨Ϊ ģʽ


//For op_mod_sel------
#define timer    				  0x00		     // 趨Ϊ ʱģʽ
//#define event  		          0x01		     // 趨Ϊ ¼ģʽ 
//#define capture  				  0x03	  	     // 趨Ϊ ģʽ
//#define pwm                     0x04		     // 趨Ϊ PWMģʽ
//#define pulse_measure           0x05		     // 趨Ϊ ģʽ
//#define ppg					  0x06		     // 趨Ϊ ɳPPGģʽ


void TMRA00_8bit_Timer_Init(); 		 			 // TMRA00 8λʱʼ
void TMRA01_8bit_Timer_Init(); 		 			 // TMRA01 8λʱʼ
void TMRA0_16bit_Timer_Init(); 		 			 // TMRA0 16λʱʼ

void TMRA00_IntEnable();					     // TMRA00ж (Enable)
void TMRA01_IntEnable();					     // TMRA01ж (Enable)

void TMRA00_IntDisable();					     // TMRA00жϽֹ (Disable)
void TMRA01_IntDisable();					     // TMRA01жϽֹ (Disable)

void TMRA00_SetPeriod(unsigned int period);	     // ʱTMRA00 趨
void TMRA01_SetPeriod(unsigned int period);	     // ʱTMRA01 趨
void TMRA0_16bit_SetPeriod(unsigned int period);   // 16λʱTMRA00+TMRA01 趨

void TMRA00_Start();							 // ʱTMRA00
void TMRA01_Start();							 // ʱTMRA01
void TMRA0_16bit_Start();						 // 16λʱTMRA00+TMRA01

void TMRA00_Stop();							 	 // ֹͣʱTMRA00
void TMRA01_Stop();							 	 // ֹͣʱTMRA01
void TMRA0_16bit_Stop();						 // ֹͣ16λʱTMRA00+TMRA01

void __interrupt TMRA00_IRQ(void);			  	 // TMRA00жӳ
void __interrupt TMRA01_IRQ(void);			  	 // TMRA01жӳ


#endif


