//*************************************************************************************
// 	: SQ7653_UART.c
// 汾		: V1.0
// 		: UART ʹú (UARTƳ)
// ע		: UART غ㼯ڱӳ
//			  SQ7653UART0,UART1,UART2 3ʹ;
//			  *ÿһUARTֱжŹѡ
//**************************************************************************************
#include "main.h"
unsigned char rbuf;                     	  // RX1յֵڴ˱

// RTʱ
const unsigned char RTTable[]={
//1Mhz
	0x00,//4800
	0x02,//9600
	0x04,//19200
	0x04,//57600
//2MHz
	0x00,//4800
	0x00,//9600
	0x02,//19200
	0x04,//57600
	0x04,//115200
	0x03,//128000
//4MHz
	0x04,//4800
	0x00,//9600
	0x00,//19200
	0x04,//57600
	0x04,//115200
	0x03,//128000
//8MHz
	0x01,//4800
	0x04,//9600
	0x00,//19200
	0x03,//57600
	0x04,//115200
	0x03,//128000
//12MHz	
	0x04,//4800
	0x00,//9600
	0x00,//19200
	0x00,//57600
	0x02,//115200
	0x03,//128000	
//16MHz
	0x01,//4800
	0x01,//9600
	0x04,//19200
	0x03,//57600
	0x03,//115200
	0x03,//128000
	0x03,//256000
//24MHz
	0x04,//9600
	0x00,//19200
	0x00,//57600
	0x00,//115200
	0x04,//128000
	0x03,//256000
};
//------------------------------------------------------------------------------
// (BaudRate)	
const unsigned char DRTable[]={
//1Mhz
	0x0C,//4800
	0x06,//9600
	0x02,//19200
	0x00,//57600
//2MHz
	0x19,//4800
	0x0C,//9600
	0x06,//19200
	0x01,//57600
	0x00,//115200
	0x00,//128000
//4MHz
	0x30,//4800
	0x19,//9600
	0x0C,//19200
	0x03,//57600
	0x01,//115200
	0x01,//128000
//8MHz
	0x64,//4800
	0x30,//9600
	0x19,//19200
	0x08,//57600
	0x03,//115200
	0x03,//128000
//12MHz
	0x92,//4800
	0x4D,//9600
	0x26,//19200
	0x0C,//57600
	0x06,//115200
	0x05,//128000
//16MHz
	0xC9,//4800
	0x64,//9600
	0x30,//19200
	0x11,//57600
	0x08,//115200
	0x07,//128000
	0x03,//256000
//24M
	0x92,//9600   
	0x4D,//19200
	0x19,//57600
	0x0C,//115200
	0x0A,//128000
	0x05,//256000
};


//*********************************************************************
// 	: UART0_Init()
// 	: UART0ʼ
// ע		: 趨żUARTز
//*********************************************************************
void UART0_Init(){

//====== UART0ܽųʼ ======

/*
	//--TXD0 (P3.7) ; RXD0 (P4.0)-------
	P3CFGCR = 0xF2;                       // P3.7趨ΪTXD0
	P4CFGCR = 0x82;                       // P4.0趨ΪRXD0
*/


//====== UART0趨 ======
/*
	PCKEN1_UART0 	= 1;                // UART0ܿ( Enable)
	UART0CR1_STOPBT = 0;                // TXֹͣλ : 1λ
	UART0CR2_STOPBR = 0;                // RXֹͣλ : 1λ	
	UART0CR1_PE 	= 0;                // żУλ

	//UART0CR1_PE 	= 1;                // żУλ
	//UART0CR1_EVEN = 1;                // 0:ͬλ 1:żͬλ

*/


}


//*********************************************************************
// 	: UART1_Init()
// 	: UART1ʼ
// ע		: 趨żUARTز
//*********************************************************************
void UART1_Init(){

//====== UART1ܽųʼ ======
	
	//--TXD1 (P1.3) ; RXD1 (P1.4)-------  [ѡ]

	P1CFGCR = 0xB3;                      // P1.3趨ΪTXD1
	P1CFGCR = 0xC3;                      // P1.4趨ΪRXD1


//====== UART1趨 ======
	PCKEN1_UART1 	= 1;                // UART1ܿ( Enable)
	UART1CR1_STOPBT = 0;                // TXֹͣλ : 1λ
	UART1CR2_STOPBR = 0;                // RXֹͣλ : 1λ	
	UART1CR1_PE 	= 0;                // żУλ
	
	//UART1CR1_PE 	= 1;                // żУλ
	//UART1CR1_EVEN = 1;                // 0:ͬλ 1:żͬλ

}


//*********************************************************************
// 	: UART2_Init()
// 	: UART2ʼ
// ע		: 趨żUARTز
//*********************************************************************
void UART2_Init(){

//====== UART2ܽųʼ ======
	
/*	
	//--TXD2 (P3.1) ; RXD2 (P3.5)-------
	P3CFGCR = 1;                       // P3.1趨ΪTXD2
	P3CFGCR = 0;                       // P3.5趨ΪRXD2      
	
*/	
	

//====== UART2趨 ======
/*
	PCKEN1_UART2 	= 1;                // UART2ܿ( Enable)
	UART2CR1_STOPBT = 0;                // TXֹͣλ : 1λ
	UART2CR2_STOPBR = 0;                // RXֹͣλ : 1λ	
	UART2CR1_PE 	= 0;                // żУλ
		
	//UART2CR1_PE 	= 1;                // żУλ
	//UART2CR1_EVEN = 1;                // 0:ͬλ 1:żͬλ
*/


}

//*********************************************************************
// 	: UART0_IntEnable()
// 	: UART0ж
// ע		: 
//*********************************************************************
void UART0_IntEnable(){
	__ASM("DI");						// ֹпж
	IER_TX0_IRQ = 1;                    // TX0ж
	IER_RX0_IRQ = 1;	                // RX0ж
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: UART1_IntEnable()
// 	: UART1ж
// ע		: 
//*********************************************************************
void UART1_IntEnable(){
	__ASM("DI");						// ֹпж
	IER_TX1_IRQ = 1;                    // TX1ж
	IER_RX1_IRQ = 1;	                // RX1ж
	__ASM("EI");						// пж
}

//*********************************************************************
// 	: UART2_IntEnable()
// 	: UART2ж
// ע		: 
//*********************************************************************
void UART2_IntEnable(){
	__ASM("DI");						// ֹпж
	IER_TX2_IRQ = 1;                    // TX2ж
	IER_RX2_IRQ = 1;	                // RX2ж
	__ASM("EI");						// пж
}




//*********************************************************************
// 	: UART0_SetBaudRate()  / UART1_SetBaudRate() / UART2_SetBaudRate()
// 	: BaudRateѡ趨
// ע		:          
//           baudSel: 
// 				SYSCLK@1MHZ
// 					SYSCLK_1MHZ_BAUD_4800		0
// 					SYSCLK_1MHZ_BAUD_9600		1
// 					SYSCLK_1MHZ_BAUD_19200		2
// 					SYSCLK_1MHZ_BAUD_57600		3
//
// 				SYSCLK@2MHZ
// 					SYSCLK_2MHZ_BAUD_4800		4
// 					SYSCLK_2MHZ_BAUD_9600		5
// 					SYSCLK_2MHZ_BAUD_19200		6
// 					SYSCLK_2MHZ_BAUD_57600		7
// 					SYSCLK_2MHZ_BAUD_115200		8
// 					SYSCLK_2MHZ_BAUD_128000		9
//
// 				SYSCLK@4MHZ
// 					SYSCLK_4MHZ_BAUD_4800		10
// 					SYSCLK_4MHZ_BAUD_9600		11
// 					SYSCLK_4MHZ_BAUD_19200		12
// 					SYSCLK_4MHZ_BAUD_57600		13
// 					SYSCLK_4MHZ_BAUD_115200		14
// 					SYSCLK_4MHZ_BAUD_128000		15
//
// 				SYSCLK@8MHZ
// 					SYSCLK_8MHZ_BAUD_4800		16
// 					SYSCLK_8MHZ_BAUD_9600		17
// 					SYSCLK_8MHZ_BAUD_19200		18
// 					SYSCLK_8MHZ_BAUD_57600		19
// 					SYSCLK_8MHZ_BAUD_115200		20
// 					SYSCLK_8MHZ_BAUD_128000		21
//
// 				SYSCLK@12MHZ
// 					SYSCLK_12MHZ_BAUD_4800		22
// 					SYSCLK_12MHZ_BAUD_9600		23
// 					SYSCLK_12MHZ_BAUD_19200		24
// 					SYSCLK_12MHZ_BAUD_57600		25
// 					SYSCLK_12MHZ_BAUD_115200	26
// 					SYSCLK_12MHZ_BAUD_128000	27
//
// 				SYSCLK@16MHZ
// 					SYSCLK_16MHZ_BAUD_4800		28
// 					SYSCLK_16MHZ_BAUD_9600		29
// 					SYSCLK_16MHZ_BAUD_19200		30
// 					SYSCLK_16MHZ_BAUD_57600		31
// 					SYSCLK_16MHZ_BAUD_115200	32
// 					SYSCLK_16MHZ_BAUD_128000	33
// 					SYSCLK_16MHZ_BAUD_256000	34
//
// 				SYSCLK@24MHZ
// 					SYSCLK_24MHZ_BAUD_9600		35
// 					SYSCLK_24MHZ_BAUD_19200		36
// 					SYSCLK_24MHZ_BAUD_57600		37
// 					SYSCLK_24MHZ_BAUD_115200	38
// 					SYSCLK_24MHZ_BAUD_128000	39
// 					SYSCLK_24MHZ_BAUD_256000	40             
//*********************************************************************

void UART0_SetBaudRate(unsigned char baudSel){

//====== UART0 ======
// ѡRTʱ
	UART0CR2_RTSEL = RTTable[baudSel];
	UART0_Stop();						// ڸıUART0DR ǰ趨UART0CR1<RXE>UART0CR1<TXE>Ϊ"0"
// ѡ(BaudRate)	
	UART0DR  =  DRTable[baudSel];

}
//--------------------------------------------------------------

void UART1_SetBaudRate(unsigned char baudSel){
	
//====== UART1 ======  /*[ʹUART1]*/

//UART1CR2 = (UART1CR2 & 0x07) | ( RTTable[baudSel] <<3);
//UART1DR  =  DRTable[baudSel];

// ѡRTʱ
	UART1CR2_RTSEL = RTTable[baudSel];
	UART1_Stop();						// ڸıUART1DR ǰ趨UART1CR1<RXE>UART1CR1<TXE>Ϊ"0"
// ѡ(BaudRate)	
	UART1DR  =  DRTable[baudSel];
	
}
//--------------------------------------------------------------
void UART2_SetBaudRate(unsigned char baudSel){

//====== UART2 ======
// ѡRTʱ
	UART2CR2_RTSEL = RTTable[baudSel];
	UART2_Stop();						// ڸıUART2DR ǰ趨UART2CR1<RXE>UART2CR1<TXE>Ϊ"0"
// ѡ(BaudRate)	
	UART2DR  =  DRTable[baudSel];
	
}



//*********************************************************************
// 	: UART0_Start()
// 	: UART0
// ע		:  TX0,RX0
//*********************************************************************
void UART0_Start(){
    UART0CR1_TXE = 1;                   //  TX0 
	UART0CR1_RXE = 1;                   //  RX0
}


//*********************************************************************
// 	: UART0_Stop()
// 	: ֹͣUART0
// ע		: ֹͣTX0,RX0
//*********************************************************************
void UART0_Stop(){
	UART0CR1_TXE = 0;                   // ֹͣTX0
	UART0CR1_RXE = 0;                   // ֹͣRX0
}



//*********************************************************************
// 	: UART1_Start()
// 	: UART1
// ע		:  TX1,RX1
//*********************************************************************
void UART1_Start(){
    UART1CR1_TXE = 1;                   //  TX1 
	UART1CR1_RXE = 1;                   //  RX1
}


//*********************************************************************
// 	: UART1_Stop()
// 	: ֹͣUART1
// ע		: ֹͣ TX1,RX1
//*********************************************************************
void UART1_Stop(){
	UART1CR1_TXE = 0;                   // ֹͣTX1
	UART1CR1_RXE = 0;                   // ֹͣRX1
}

//*********************************************************************
// 	: UART2_Start()
// 	: UART2
// ע		:  TX2,RX2
//*********************************************************************
void UART2_Start(){
    UART2CR1_TXE = 1;                   //  TX2 
	UART2CR1_RXE = 1;                   //  RX2
}


//*********************************************************************
// 	: UART2_Stop()
// 	: ֹͣUART2
// ע		: ֹͣ TX2,RX2
//*********************************************************************
void UART2_Stop(){
	UART2CR1_TXE = 0;                   // ֹͣTX2
	UART2CR1_RXE = 0;                   // ֹͣRX2
}



//*********************************************************************
// 	: UART0_TX_OneByte()
// 	: UART0 TX䷶
// ע		:
//            data: TX͵
//*********************************************************************
void UART0_TX_OneByte(unsigned char data){
	
	while(UART0SR_TBFL == 1){			// ȴͻΪգٴдҪ֮
		CLR_WDT;						// Źʱ (ι)
    }
	TD0BUF = data;						// дҪ֮
    
	while(UART0SR_TBSY ==1){			// 1:䷢ , 0:ǰȴ͹
        CLR_WDT;						// Źʱ (ι)
    }
}


//*********************************************************************
// 	: UART0_RX_OneByte()
// 	: UART0 RXշ
// ע		:
//            return : RXҪյ
//*********************************************************************
unsigned char UART0_RX_OneByte(){	
	
    while(!UART0SR_RBFL);               // ȴUART0 RD0BUFյ
	return RD0BUF;                      // յRD0BUF

}

//*********************************************************************
// 	: UART1_TX_OneByte()
// 	: UART1 TX䷶
// ע		:
//            data: TX͵
//*********************************************************************
void UART1_TX_OneByte(unsigned char data){

	while(UART1SR_TBFL == 1){			 // ȴͻΪգٴдҪ֮
		CLR_WDT;						 // Źʱ (ι)
    }
	TD1BUF = data;						 // дҪ֮
    
	while(UART1SR_TBSY ==1){			 // 1:䷢ , 0:ǰȴ͹
        CLR_WDT;						 // Źʱ (ι)
    }
}


//*********************************************************************
// 	: UART1_RX_OneByte()
// 	: UART1 RXշ
// ע		:
//            return : RXҪյ
//*********************************************************************
unsigned char UART1_RX_OneByte(){	
    
    while(!UART1SR_RBFL);               // ȴUART1 RD1BUFյ
	return RD1BUF;                       // յRD1BUF

}


//*********************************************************************
// 	: UART2_TX_OneByte()
// 	: UART2 TX䷶
// ע		:
//            data: TX͵
//*********************************************************************
void UART2_TX_OneByte(unsigned char data){

	while(UART2SR_TBFL == 1){			 // ȴͻΪգٴдҪ֮      
		CLR_WDT;                     	 // Źʱ (ι)
    }
	TD2BUF = data;						 // дҪ֮
    
	while(UART2SR_TBSY ==1){			 // 1:䷢ , 0:ǰȴ͹
        CLR_WDT;                         // Źʱ (ι)
    }
}

//*********************************************************************
// 	: UART2_RX_OneByte()
// 	: UART2 RXշ
// ע		:
//           return : RXҪյ
//*********************************************************************
unsigned char UART2_RX_OneByte(){
    
    while(!UART2SR_RBFL);               // ȴUART2 RD2BUFյ
	return RD2BUF;                      // յRD2BUF
}

//*********************************************************************
// 	: UART_ReadState()
// 	: ȡش UART ״̬
// ע		:
//           uart: UART_0, UART_1, UART_2
//           return UART ״̬
//*********************************************************************

unsigned char UART_ReadState(unsigned char uart){
	if(uart==UART_0){
		return UART0SR;
	}
	else if(uart==UART_1){
		return UART1SR;
	}
	else if(uart==UART_2){
		return UART2SR;
	}
	else
		return 0;
}

//*********************************************************************
// 	: UART_TX_OneByte()
// 	: UART TX䷶
// ע		:
//           uart: UART_0, UART_1, UART_2
//           data: TX͵
//*********************************************************************
void UART_TX_OneByte(unsigned char uart,unsigned char data){
	
	if(uart==UART_0){
		while(UART0SR_TBFL);			// ȴͻΪգٴдҪ֮
		TD0BUF = data;					// дҪ֮
		while(UART0SR_TBFL);
	}
	else if(uart==UART_1){
		while(UART1SR_TBFL);			// ȴͻΪգٴдҪ֮
		TD1BUF = data;					// дҪ֮
		while(UART1SR_TBFL);
	}
	else if(uart==UART_2){
		while(UART2SR_TBFL);			// ȴͻΪգٴдҪ֮
		TD2BUF = data;					// дҪ֮
		while(UART2SR_TBFL);
	}	
	
}


//*********************************************************************
// 	: UART_Send()
// 	: UART TX
// ע		: *Ҫϲֻ1Byteʱʹãʹ趨䳤ȴС
//			  uart: UART_0, UART_1, UART_2
//           
//*********************************************************************
void UART_Send(unsigned char uart,unsigned char* buf, unsigned char len){
	
	unsigned char i;
	for(i=0;i<len;i++){
		if(uart==UART_0){
			while(UART0SR_TBFL);        // UART0 TD0BUF
			TD0BUF = buf[i];            // ҪͳY
		}
		else if(uart==UART_1){
			while(UART1SR_TBFL);        // UART1 TD1BUF
			TD1BUF = buf[i];            // ҪͳY
		}
		else if(uart==UART_2){
			while(UART2SR_TBFL);        // UART2 TD2BUF
			TD2BUF = buf[i];            // ҪͳY
		}

	}
}

//*********************************************************************
// 	: UART_Nibble2Ascii()
// 	: λԪתAscii
// ע		:           
//*********************************************************************
unsigned char UART_Nibble2Ascii(unsigned char anibble)
{
	unsigned char	ascii_out = anibble;

	if(anibble > 9)						// If req ASCII A-F then add 7(hex)
	{	
		ascii_out = ascii_out + 0x07;
	}

	// Add offset to convert to Ascii
	ascii_out = ascii_out + 0x30;

	return(ascii_out);
}


//*********************************************************************
// 	: UART_PutByte()
// 	: õ high nibbleת ASCII TXͣõ low nibbleת ASCII TX
// ע		: 
//			  uart: UART_0, UART_1, UART_2
//*********************************************************************
void UART_PutByte(unsigned char uart,unsigned char abyte)
{
	unsigned char  temp1 = 0, temp2 = 0;	

	temp1 = (abyte >> 4) & 0x0F;		// õ high nibble
	temp2 = UART_Nibble2Ascii(temp1);	// high nibbleת ASCII
	UART_TX_OneByte(uart,temp2);		// 

	temp1 = abyte & 0x0F;				// õ low nibble
	temp2 = UART_Nibble2Ascii(temp1);	// low nibbleת ASCII
	UART_TX_OneByte(uart,temp2);		// 
}



//*********************************************************************
// 	: UART_PutDecNumber()
// 	: 
// ע		: ***Input value range : 0~9999 
//*********************************************************************
void UART_PutDecNumber(unsigned int value)
{
	unsigned char print_buf[4];  
	 
    if(value > 9999)
       value = 9999; 		
	
	print_buf[0] = ((value%10000)/1000)+'0';
	print_buf[1] = ((value%1000)/100)+'0';
	print_buf[2] = ((value%100)/10)+'0';
	print_buf[3] = ((value%10))+'0';
	 
	UART_Send(UART_1,print_buf,4);	
}

//*********************************************************************
// 	: UART_PutCrlf()
// 	: ͶԪ
// ע		: 
//*********************************************************************
void UART_PutCrlf(void)
{

/*	
    UART_TX_OneByte(UART_0,'\r');
	UART_TX_OneByte(UART_0,'\n');
*/	

	UART_TX_OneByte(UART_1,'\r');
	UART_TX_OneByte(UART_1,'\n');

/*	
    UART_TX_OneByte(UART_2,'\r');
	UART_TX_OneByte(UART_2,'\n');
*/	
	
}


//*********************************************************************
// 	: UART_SendCString()
// 	: ִ
// ע		:  
//*********************************************************************
void UART_SendCString(const char *pstr)
{
	while(*pstr != 0)
	{	
	    if(*pstr == '\n')
		   	UART_PutCrlf();
		else
		
			//UART_TX_OneByte(UART_0,*pstr);
		    UART_TX_OneByte(UART_1,*pstr);
		    //UART_TX_OneByte(UART_2,*pstr);

		pstr++;
	}
}



//*********************************************************************
// 	: __interrupt RX0_IRQ()
// 	: RX0 жӳ
// ע		:
//*********************************************************************
void __interrupt RX0_IRQ(void)
{
	__asm("NOP");						// ָ
	

}


//*********************************************************************
// 	: __interrupt RX1_IRQ()
// 	: RX1 жӳ
// ע		: ȡϣյϷϴϣӦLED
//*********************************************************************
void __interrupt RX1_IRQ(void)
{
	__asm("NOP");						// ָ

	rbuf = UART1_RX_OneByte();          // 
	if(rbuf == 0x55){					
		LED1_out = 0;					// 0x55LED1(P0.0)
        LED2_out = 1;
        LED3_out = 1;		
	}
	else if(rbuf == 0xAA){				
		LED1_out = 1;					// 0xAALED2(P0.1)
	    LED2_out = 0;
	    LED3_out = 1;
	}
	else if(rbuf == 0x76){				
		LED1_out = 1;					// 0x76LED3(P0.2)
	    LED2_out = 1;
	    LED3_out = 0;
	
	}		

}


//*********************************************************************
// 	: __interrupt RX2_IRQ()
// 	: RX2 жӳ
// ע		:
//*********************************************************************
void __interrupt RX2_IRQ(void)
{
	__asm("NOP");						// ָ

}



//*********************************************************************
// 	: __interrupt TX0_IRQ()
// 	: TX0 жӳ
// ע		:
//*********************************************************************
void __interrupt TX0_IRQ(void)
{
	__asm("NOP");						// ָ

	
}



//*********************************************************************
// 	: __interrupt TX1_IRQ()
// 	: TX1 жӳ
// ע		:
//*********************************************************************
void __interrupt TX1_IRQ(void)
{
	__asm("NOP");						// ָ

}



//*********************************************************************
// 	: __interrupt TX2_IRQ()
// 	: TX2 жӳ
// ע		:
//*********************************************************************
void __interrupt TX2_IRQ(void)
{
	__asm("NOP");						// ָ

}
