//******************************************
//  : SQ7653_TMRA_Complementary
// 汾     : V 1.00 2019/03/20 SQ7653
//      : TMRA0 Complementary ʹú
// ע     :
//******************************************

#include "main.h"

unsigned char TMRA00_Int_Flag;		  	// TMRA00жϷ
unsigned char TMRA01_Int_Flag;		  	// TMRA01жϷ
//*********************************************************************
//    : TMRA00_Timer_Init
//  : TMRA00 8λrģʽr100us
// ע     :
//*********************************************************************
void TMRA00_Timer_Init(void)
{
//====== ܿ( Enable) ======
    PCKEN0_TMRA0 = 1;                   // ȿݴò
    
	
//====== 趨 ======
    TMRA0CFG_TCFG   = set_8bit;         // 趨Ϊ 8 bit ģʽ
    TMRA0MD0_TCM    = timer;            // 趨Ϊ 8 λʱģʽ
    TMRA0MD0_TCK    = 5;                // fcgck/4 = ??MHz = ??us
    TMRA0MD0_DBE    = 1;                // ʹ˫
    
    TMRA0DR0        = 100;              // 趨ֵ: ÿ 100 * ??us жһ (ֵ=T00REG*T00MOD_TCK)
}


//*********************************************************************
//    : TMRA0_16BIT_Complementary_Init
//  : ûʽ}
// ע     : ʽ : TMRA0PWM1/TMRA0PWM0   (16λʽ PPGģʽ Duty 趨)
//                   : TMRA0DR/TMRA0DR0      (16λʽ PPGģʽ Cycle 趨)
//*********************************************************************
void TMRA0_16BIT_Complementary_Init(void)
{
	//====== ܽųʼ ======
    P0DO_P4         = 1;                // ܽʼ P04ߵƽ  **ͬ PPG ĳʼֵ(T0xMOD_TFF)
    P0DO_P5         = 1;
	P0OE_P4         = 1;                // P04ܽ趨Ϊ
    P0OE_P5         = 1;
//====== ܿ( Enable) ======
    PCKEN0_TMRA0    = 1;                // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = complementary;    // 趨Ϊ Complementary ģʽ     
    TMRA0MD1_TCM    = PPG;              // 趨Ϊ  16λɱ Complementary ģʽ
	
	TMRA0MD1_TFF    = 0;                // 趨ʼֵΪ"׼λ"ռձ(TMRMD1.TFFO0,TMRMD0.TFFԄO1)
   
    TMRA0MD1_TCK    = 5;                // fcgck/4 = 1MHz = 1us
	TMRA0MD0_DBE    = 1;                // ʹ˫
    TMRA0MD1_DBE    = 1;                // ʹ˫

    TMRA0CPL_CPLMD  = 0x00;             // ʽ}mode(CPLMD) ʽ
   
    TMRA0PWM0       = 160;              // 趨 PPG Duty ,14496
    TMRA0PWM1       = 54; 
	
	TMRA0DR0        = 200;              // 趨 PPG Cycle ,18120   	  
	TMRA0DR1        = 70;               // 14496/18120 = 80%
	//	***PxCFGCR ùţڳʼֵ趨֮ PxCFGCR
    P0CFGCR         = 0xC1;             // лP04Ϊ⹦ܽ,ܽ趨Ϊʽ  PPG 
	P0CFGCR         = 0xD1;             // лP05Ϊ⹦ܽ,ܽ趨Ϊʽ ~PPG 
	
}

//*********************************************************************
//    : TMRA1_16BIT_Complementary_Init
//  : ûʽ}
// ע     : ʽ : TMRA0PWM1/TMRA0DR1   (16λPPGģʽ)
//                   : TMRA0PWM0/TMRA0DR0   (16λʽ PPG ģʽ)
//*********************************************************************
void TMRA1_16BIT_Complementary_Init(uchar CP_mode)
{
	//====== ܽųʼ ======
    P0DO_P2         = 1;                // ܽʼ P02ߵƽ  **ͬ PPG ĳʼֵ(T0xMOD_TFF)
    P0DO_P3         = 1;
	P0OE_P2         = 1;                // P02ܽ趨Ϊ
    P0OE_P3         = 1;
//====== ܿ( Enable) ======
    PCKEN0_TMRA1    = 1;                // ȿݴò

//====== 趨 ======
    TMRA1CFG_TCFG   = complementary;    // 趨Ϊ Complementary ģʽ 
    TMRA1MD1_TCM    = PPG;              // 趨Ϊ  16λɱ Complementary ģʽ
	
	TMRA1MD1_TFF    = 0;                // 趨ʼֵΪ"׼λ"ռձ(TMRMD1.TFFO0,TMRMD0.TFFԄO1)
    
    TMRA1MD1_TCK    = 5;                // fcgck/4 = 1MHz = 1us
	TMRA1MD0_DBE    = 1;                // ʹ˫
    TMRA1MD1_DBE    = 1;                // ʹ˫

    TMRA1CPL_CPLMD  = CP_mode;          // ʽ}䣬ʽ mode.
   
    if(CP_mode == 2){
		NOP;                            //  TMRA0 Complementary mode  Duty  Cycle	  
	}
	else if(CP_mode == 3){
		TMRA1PWM0   = 198;              // 趨ռձ(6342/18120)= 35%Cycle ͬ TMRA0  
		TMRA1PWM1   = 24;
	}
	else{                               //CPLMD=0,  PPG ģʽ趨 Duty  Cycle
		TMRA1PWM0   = 100;            
		TMRA1PWM1   = 40;
		TMRA1DR0    = 200;          	  
		TMRA1DR1    = 80;
	}
	//	***PxCFGCR ùţڳʼֵ趨֮ PxCFGCR
    P0CFGCR         = 0xA1;             // лP02Ϊ⹦ܽ,ܽ趨Ϊ PPG 
	P0CFGCR         = 0xB1;             // лP03Ϊ⹦ܽ,ܽ趨Ϊ ~PPG 
}

//*********************************************************************
//    : TMRA0_16BIT_SetDuty
//  : }ֵ
// ע     : ռձ : TMRA0PWM0/TMRA0DR0      (8λPPGģʽ)
//                   : TMRA0PWM0_PWMDUTY/128 (8λPWMģʽ)
//*********************************************************************
void TMRA0_16BIT_SetDuty(uint duty)
{
    
	TMRA0PWM0       = (duty & 0xFF);
	TMRA0PWM1       = ((duty & 0xFF00)>>8);
}

//*********************************************************************
//    : TMRA00_16BIT_SetPeriod
//  : Lڼֵ
// ע     : 
//*********************************************************************
void TMRA0_16BIT_SetPeriod(uint period)
{
    TMRA0DR0        = (period & 0xFF);
	TMRA0DR1        = ((period & 0xFF00)>>8);
}



//*********************************************************************
//    : TMRA0_SetDeadTime
//  :  Dead Timeֵ
// ע     : Dead Time : scale Ϊֵ 0(1),1(2),2(4),3(8) 
//                          : Dtime Ϊֵ , Dead Time = ֵ(scale) x ֵ(Dtime)
//*********************************************************************
void TMRA0_SetDeadTime(uchar scale, uchar Dtime)
{
    TMRA0DTM_DTMPSC  = scale;
	if(Dtime > 63)
		TMRA0DTM_DTM = 63;
	else 
		TMRA0DTM_DTM = Dtime;	
}

//*********************************************************************
//    : TMRA0_Fault_Detect_Init
//  :  ʽ}䣬ֹͣ
// ע     : ֹͣ : 00 ֹܹͣر, 01 ֹͣΪ (0,0) 
//            TMRA0CPL_FLTMD : 10 ֹͣΪʼ趨ֵ, 10 ֹͣΪĳʼ趨ֵ
//*********************************************************************
void TMRA0_Fault_Detect_Init(uchar FD_mode)
{
    DI;	
	if(FD_mode < 4)
		TMRA0CPL_FLTMD = FD_mode;       //ֹֹͣͣ趨ѡ(0,1,2,3)
	else 
		TMRA0CPL_FLTMD = 1;             //01 ֹͣ趨Ϊ (0,0)
	
	P4CFGCR         = 0x91;             // лP41Ϊ⹦ܽ,ܽ趨Ϊ FLTIN0(TMRA0 Fault Detection)
	IER_TMRA00_IRQ = 1;                // 趨ж
	TMRA0CPL_FLTIE  = 1;                // 趨Fault Detection ж
	EI;		
}

//*********************************************************************
//    : TMRA00_Start
//  : TC00
// ע     :
//*********************************************************************
void TMRA00_Start(void)
{
    TMRA0CR0_RUN   = 1;                // ʱTimmer00
}

//*********************************************************************
//    : TMRA01_Start
//  : TMRA01 & 16BIT TMRA0
// ע     :
//*********************************************************************
void TMRA01_Start(void)
{
    TMRA0CR1_RUN   = 1;                // ʱTimmer01
}

//*********************************************************************
//    : TMRA01_Start
//  : TMRA01 & 16BIT TMRA0
// ע     :
//*********************************************************************
void TMRA11_Start(void)
{
    TMRA1CR1_RUN   = 1;                // ʱTimmer11
}

//*********************************************************************
//    :TMRA00_Stop
//  : ֹͣTMRA00
// ע     :
//*********************************************************************
void TMRA00_Stop(void)
{
    TMRA0CR0_RUN   = 0;                // ֹͣʱTimmer00
}

//*********************************************************************
//    :TMRA01_Stop
//  : ֹͣTMRA00 & 16BIT TMRA0
// ע     :
//*********************************************************************
void TMRA01_Stop(void)
{
    TMRA0CR1_RUN   = 0;                // ֹͣʱTimmer01
}

//*********************************************************************
//    :TMRA11_Stop
//  : ֹͣTMRA00 & 16BIT TMRA0
// ע     :
//*********************************************************************
void TMRA11_Stop(void)
{
    TMRA1CR1_RUN   = 0;                // ֹͣʱTimmer11
}
//*********************************************************************
//    : TMRA00_IntEnable
//  : TMRA00ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA00_IntEnable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IFR_TMRA00_IRQ = 0;                // ж
    IER_TMRA00_IRQ = 1;                // 趨ж
    EI;                                 // пж // EIRL_IMF=1
}


//*********************************************************************
//    : TMRA01_IntEnable
//  : TMRA01 & 16BIT TMRA0 ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA01_IntEnable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IFR_TMRA01_IRQ = 0;                // ж
    IER_TMRA01_IRQ = 1;                // 趨ж
    EI;                                 // пж // EIRL_IMF=1
}


//*********************************************************************
//    : TMRA00_IntDisable
//  : ֹTMRA00ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA00_IntDisable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IFR_TMRA00_IRQ = 0;                // ж
    IER_TMRA00_IRQ = 0;                // ж
    EI;                                 // пж // EIRL_IMF=1
}

//*********************************************************************
//    : TMRA01_IntDisable
//  : ֹTMRA01 & 16BIT TMRA0ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA01_IntDisable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IFR_TMRA01_IRQ = 0;                // ж
    IER_TMRA01_IRQ = 0;                // ж
    EI;                                 // пж // EIRL_IMF=1
}

//*********************************************************************
//    : TMRA00_IRQ
//  : жϸʽ
// ע     :
//*********************************************************************
void __interrupt TMRA00_IRQ(void)
{
    //P9DR_P0 = !P9DR_P0;				// 趨P90
	TMRA00_Int_Flag = 1;
    NOP;                                // ָ
}

//*********************************************************************
//    : TMRA01_IRQ
//  : жϸʽ
// ע     :
//*********************************************************************
void __interrupt TMRA01_IRQ(void)
{
    //P9DR_P0 = !P9DR_P0;				// 趨P90
	TMRA01_Int_Flag = 1;
    NOP;                                // ָ
}

//*********************************************************************
//    : TMRA11_IRQ
//  : жϸʽ
// ע     :
//*********************************************************************
void __interrupt TMRA11_IRQ(void)
{
    //P9DR_P0 = !P9DR_P0;				// 趨P90
    NOP;                                // ָ
}


