//*************************************************************************************
// 	: SQ7653_TMRA0.c
// 汾		: V1.0 2020/07/17A
// 		: Timer A0 (TMRA0)ʹú
// ע		: TMRA0 غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned char TMRA00_Int_Flag;		  	// TMRA00жϷ
unsigned char TMRA01_Int_Flag;		  	// TMRA01жϷ

//*********************************************************************
// 	: TMRA0_Timer_Init()
// 	: TMRA0 ʱģʽʼ
// ע		: t_mode_sel:
//						set_8bit    	:趨Ϊ 8λģʽ
//						output  		:趨Ϊ ʱģʽ 
//						set_16bit		:趨Ϊ 16λģʽ
//						pre_scale   	:趨Ϊ ԤȷƵģʽ
//						complementary	:趨Ϊ ģʽ
//
// 		: ҪTMRA0ʱΪ16λԪģʽʹʾ:
//			  TMRA0_Timer_Init(16bit);	//16λģʽ
//*********************************************************************
void TMRA0_Timer_Init(unsigned char t_mode_sel){

//====== ܿ( Enable) ======
	PCKEN0_TMRA0 = 1;                   // TMRA0ܿ( Enable)  *ȿݴò

//====== TMRA0 ʱģʽѡ ======
	TMRA0CFG_TCFG = t_mode_sel;			// 趨TMRA0ģʽ
	
}


//*********************************************************************
// 	: TMRA00_Init()
// 	: TMRA00 ʱʼ
// ע		: op_mode_sel:
//						 timer  				 :趨Ϊ ʱģʽ
//						 event_counter 			 :趨Ϊ ¼ģʽ 
//						 capture 				 :趨Ϊ ׽ģʽ
//						 pulse_width_modulation  :趨Ϊ PWMģʽ
//						 pulse_width_measurement :趨Ϊ ģʽ
//						 PPG					 :趨Ϊ ɳPPGģʽ
//*********************************************************************
void TMRA00_Init(unsigned char op_mode_sel){

//====== ʱA0 Counter0 (TMRA00)趨 ======
	//Դʱѡ=>
	TMRA0MD0_TCK = 0x01;				// ʱTMRA00Դʱѡ,TMRA00 clock A 1024 (24M/1024=23437.5)λʱԼΪ0.0426ms	

	TMRA0MD0_TCM = op_mode_sel;			// ģʽ趨

}



//*********************************************************************
// 	: TMRA01_Init()
// 	: TMRA01 ʱʼ
// ע		: op_mode_sel:
//						 timer  				 :趨Ϊ һ㶨ʱģʽ
//						 event_counter 			 :趨Ϊ ¼ģʽ 
//						 capture 				 :趨Ϊ ģʽ
//						 pulse_width_modulation  :趨Ϊ ģʽ
//						 pulse_width_measurement :趨Ϊ ģʽ
//						 PPG					 :趨Ϊ ɳPPG ģʽ
//*********************************************************************
void TMRA01_Init(unsigned char op_mode_sel){

//====== ʱA0 Counter1 (TMRA01)趨 ======
	//Դʱѡ=>
	TMRA0MD1_TCK = 0x01;				// ʱTMRA01Դʱѡ,TMRA01 clock A 1024 (24M/1024=23437.5)λʱԼΪ0.0426ms

	TMRA0MD1_TCM = op_mode_sel;			// ģʽ趨
	
}


//*********************************************************************
// 	: TMRA00_IntEnable()
// 	: TMRA00жEnable
// ע		: 
//*********************************************************************
void TMRA00_IntEnable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA00_IRQ = 1;                 // TMRA00 Д
	
	//TMRA0CR0_TMROVIE = 0;             // λжϿ,λʱTMRA00жҪ
	//TMRA0CR0_TMROVIE = 1;             // λжϿ,λʱTMRA00жҪ
	
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: TMRA01_IntEnable()
// 	: TMRA01жEnable
// ע		: 
//*********************************************************************
void TMRA01_IntEnable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA01_IRQ = 1;                 // TMRA01 Д
	
	//TMRA0CR1_TMROVIE = 0;             // λжϿ,λʱTMRA01жҪ
	//TMRA0CR1_TMROVIE = 1;             // λжϿ,λʱTMRA01жҪ
	
	__ASM("EI");						// пж
}



//*********************************************************************
// 	: TMRA00_SetPeriod()
// 	: ʱTMRA00 趨
// ע		: Timer A0,Counter0
//*********************************************************************
void TMRA00_SetPeriod(unsigned int period){	
	TMRA0DR0 = period;              	// 趨TMRA00

}


//*********************************************************************
// 	: TMRA01_SetPeriod()
// 	: ʱTMRA01 趨
// ע		: Timer A0,Counter1
//*********************************************************************
void TMRA01_SetPeriod(unsigned int period){	
	TMRA0DR1 = period;              	// 趨TMRA01

}


//*********************************************************************
//    : TMRA0_16bit_SetPeriod()
//  : 16λʱTMRA00+TMRA01 趨
// ע     : Timer A0,Counter0 + Counter1
//*********************************************************************
void TMRA0_16bit_SetPeriod(unsigned int period){    
    TMRA0DR0 = period&0xff;             // 趨λ
    TMRA0DR1 = period>>8;               // 趨λ
	
}


//*********************************************************************
// 	: TMRA00_Start()
// 	: ʱTMRA00
// ע		: 
//*********************************************************************
void TMRA00_Start(){
	TMRA0CR0_RUN = 1;                   // TMRA00ʼ
	
}


//*********************************************************************
// 	: TMRA01_Start()
// 	: ʱTMRA01
// ע		: 
//*********************************************************************
void TMRA01_Start(){
	TMRA0CR1_RUN = 1;                   // TMRA01ʼ
	
}


//*********************************************************************
// 	: TMRA0_16bit_Start()
// 	: 16λʱTMRA00+TMRA01
// ע		: 
//*********************************************************************
void TMRA0_16bit_Start(){
	TMRA0CR1_RUN = 1;                   // 16λʱ
	
}


//*********************************************************************
// 	: TMRA00_Stop()
// 	: ֹͣʱTMRA00
// ע		: 
//*********************************************************************
void TMRA00_Stop(){
	TMRA0CR0_RUN = 0;                   // TMRA00ֹͣʱ

}


//*********************************************************************
// 	: TMRA01_Stop()
// 	: ֹͣʱTMRA01
// ע		: 
//*********************************************************************
void TMRA01_Stop(){
	TMRA0CR1_RUN = 0;                   // TMRA01ֹͣʱ

}


//*********************************************************************
// 	: TMRA0_16bit_Stop()
// 	: ֹͣ16λʱTMRA00+TMRA01
// ע		: 
//*********************************************************************
void TMRA0_16bit_Stop(){
	TMRA0CR1_RUN = 0;                   // ֹͣ16λʱ
	
}


//*********************************************************************
// 	: __interrupt TMRA00_IRQ()
// 	: TMRA00жӳ
// ע		:
//*********************************************************************
void __interrupt TMRA00_IRQ(void){
	__asm("NOP");						// ָ
	TMRA00_Int_Flag = 1;				// TMRA00жϷ趨Ϊ1
	
	
}


//*********************************************************************
// 	: __interrupt TMRA01_IRQ()
// 	: TMRA01жӳ
// ע		:
//*********************************************************************
void __interrupt TMRA01_IRQ(void){
	__asm("NOP");						// ָ
	TMRA01_Int_Flag = 1;				// TMRA01жϷ趨Ϊ1
	
	
}

