//******************************************
//  : SQ7653_8BIT_TMRAx
// 汾     : V 1.00 2019/12/12SQ7653
//      : 
// ע     :
//******************************************
#ifndef _SQ7653_TMRA0_H__
#define _SQ7653_TMRA0_H__


/******************
 * 1st Argument
 * ****************/
/* ---------------------- Զ ------------------------------ */
//For t_mod_sel------
#define set_8bit    			0x00		     	// 趨Ϊ 8λģʽ
#define output  				0x01		     	// 趨Ϊ ʱģʽ 
#define set_16bit  			    0x02		     	// 趨Ϊ 16λģʽ
#define pre_scale   			0x04		     	// 趨Ϊ ԤȷƵģʽ
#define complementary   		0x05		     	// 趨Ϊ ģʽ

//For op_mod_sel------
#define timer    				0x00		    	// 趨Ϊ ʱģʽ
#define event_counter  		    0x01		     	// 趨Ϊ ¼ģʽ 
#define capture  				0x03	  	     	// 趨Ϊ ģʽ
#define PWM  					0x04		     	// 趨Ϊ PWMģʽ
#define pulse_measure 		    0x05		     	// 趨Ϊ ģʽ
#define PPG						0x06		     	// 趨Ϊ ɳPPGģʽ

void TMRA00_Timer_Init(void);
void TMRA00_PPG_Init(void);
void TMRA00_PWM_Init(void);
void TMRA00_ECounter_Init(void);

void TMRA0_12BIT_PWM_Init(void);
void TMRA0_16BIT_ECounter_Init(void);
void TMRA0_16BIT_PPG_Init(void);
//====================
void TMRA0_Prescale_PPG_Init(void);
//====================

void TMRA00_SetDuty(uchar duty); 		           //20190125
void TMRA00_SetPeriod(uchar period); 	           //20190125
void TMRA01_SetDuty(uchar duty); 		           //20190125
void TMRA01_SetPeriod(uchar period); 	           //20190125
void TMRA0_16BIT_SetDuty(uint duty);
void TMRA0_16BIT_SetPeriod(uint period);
//======================
void TMRA0_SetPrescale(uchar duty); 		       //20190125
//======================

void TMRA00_Start(void);
void TMRA01_Start(void);
void TMRA00_Stop(void); 
void TMRA01_Stop(void);

void TMRA00_IntEnable(void);
void TMRA01_IntEnable(void);
void TMRA00_IntDisable(void);
void TMRA01_IntDisable(void);

void __interrupt TMRA00_IRQ(void);
void __interrupt TMRA01_IRQ(void);

void TMRA10_PPG_Init(void);
void TMRA10_Start(void);
void TMRA10_Stop(void);

#endif








