//SQ7653_TMRA0_16BIT_Timer_TMRA4_16BIT_PulseMeasure
//--ʱģʽ(TMRA0,16BIT,Timer mode)
//--ģʽ(TMRA4,16BIT,PulseMeasure mode)

//*************************************************************************************
// 	: main.c
// 汾		: V1.0 2020/07/17A
// 		: 
// ˵	: ʹõһSQ7653趨
//			  1. TMRA0趨Ϊ16λʱģʽ  ۻ趨ȣжϣ(P1.7)
//			  2. TMRA4趨Ϊ16λģʽTMRA0
//
//			  ʼTMRA0ʱΪΪ 85.33 msɰ1~3ı䣬
//
//			  °1: 趨TMRA0Ϊ 85.33 msTMRA4ȷ,LED1δLED1
//      	  °2: 趨TMRA0Ϊ170.62 msTMRA4ȷ,LED2δLED2
//      	  °3: 趨TMRA0Ϊ 42.655msTMRA4ȷ,LED3δLED3
//
// ע		: 1. TMRA0ѶܽΪ(P1.7)
//			  2. TMRA4ѶܽΪTA4G(P0.3)
//			  3. *轫(P1.7)----ӵ----TA4G(P0.3)
//			  4. []	1  BTN1_in(P1.0)
//						    2  BTN2_in(P1.1)
//						    3  BTN3_in(P1.2)
// 
//				  [LED] LED 1  (P0.0)
//				  [LED] LED 2  (P0.1)
//				  [LED] LED 3  (P0.2)
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"

/* ----------------------  -------------------------- */
// ϵͳƵΪPLL 24MHz,
// ʱTMRA41Դʱѡ,A 2^11 (24M/2048=11.718KHz)λʱԼΪ0.08533ms
long double TCA_count_scale= 0.08533;			 // ÿһCount֮λʱ(ms)
//------------------------------------------------------------

long double Measure_Period;
long double Measure_H_Pulse_width, Measure_L_Pulse_width;

/* -----------------------  --------------------------- */
void main()
{
/* ---------------------- ϵͳʼ ------------------------ */
//  ϵͳʱԤΪPLL 24MHz
/* ---------------------- ܽųʼ ------------------------ */
    P0OE  = 0x07;                        	     // 趨P0.0,P0.1,P0.2 ܽΪ
    P1OE  = 0x80;                        	     // 趨P1.7ܽΪ趨P1.0,P1.1,P1.2 ܽΪ
	P1PU |= 0x07;                       	     // 趨P1.0,P1.1,P1.2 
	LED1_out = 1;							     // ʼ趨LED1Ϊ״̬
	LED2_out = 1;							     // ʼ趨LED2Ϊ״̬
	LED3_out = 1;							     // ʼ趨LED3Ϊ״̬
/* -------------------- TMRA0ʼ ----------------------------------- */	
	TMRA0_16bit_Timer_Init(); 			  		 // TMRA0_16bit ʱģʽʼ
	TMRA01_IntEnable();                          // TMRA01ж
    TMRA0_16bit_SetPeriod(d_1000Count);	     	 // 趨(Ϊ 85.33ms)
	TMRA0_16bit_Start();					     // ʼ		
	
/* -------------------- TMRA4ʼ ----------------------------------- */	
	TMRA4_16bit_PulseMeasure_Init();             // Counter1(TMRA41)ʼΪ
	TMRA41_IntEnable();                          // TMRA41ж
	TMRA4_16bit_Start();					     // ʼ
	__ASM("NOP");								 // ָ
//------------------------------------------------------------------------------
    while(1){
		if(TMRA01_Int_Flag){
			TMRA01_Int_Flag = 0;				 // TMRA01жϷΪ0һεж
            P1DO_P7 = ~ P1DO_P7;		  	  	 // (P1.7) 򣬱ʾTMRA01ДM		
		}
		//----------------------------------------------------------------------
		if(TMRA41_Int_Flag){
			TMRA41_Int_Flag = 0;				 // TMRA41жϷΪ0һεж
			
			//ص½() λms
			Measure_H_Pulse_width = (((long double)TCA_count_scale)*(long double)H_pulse_measure_count);
			
			/*
		    //ص() λms
			//Measure_Period = (((long double)TCA_count_scale)*(long double)measure_count);	
			*/
			
		//----------------------------------------------------------------------
			if(H_pulse_measure_count == 1000){               	  	 // LED1(P0.0)
			   LED1_out = 0;
			   LED2_out = 1;
	           LED3_out = 1;			
			}
			else if(H_pulse_measure_count == 2000){          	  	 // LED2(P0.1)
			   LED1_out = 1;
			   LED2_out = 0;
	           LED3_out = 1;
				
			}
			else if(H_pulse_measure_count == 500){          	  	 // LED3(P0.2)
			   LED1_out = 1;
			   LED2_out = 1;
	           LED3_out = 0;						
			}

			
		}
		//----------------------------------------------------------------------
		if(BTN1_in == 0){               	  	 // 1
			TMRA0_16bit_Stop();                	 // TMRA0ֹͣ *ֹֻͣ״̬¸ı䶨ʱ
			TMRA0_16bit_SetPeriod(d_1000Count);  // TMRA0趨(Ϊ 85.33 ms)
			TMRA0_16bit_Start();               	 // TMRA0ʼ
		}
		if(BTN2_in == 0){               	     // 2
			TMRA0_16bit_Stop();                	 // TMRA0ֹͣ *ֹֻͣ״̬¸ı䶨ʱ
			TMRA0_16bit_SetPeriod(d_2000Count);  // TMRA0趨(Ϊ170.62 ms)
			TMRA0_16bit_Start();               	 // TMRA0ʼ
		}
		if(BTN3_in == 0){               	 	 // 3
			TMRA0_16bit_Stop();                	 // TMRA0ֹͣ *ֹֻͣ״̬¸ı䶨ʱ
			TMRA0_16bit_SetPeriod(d_500Count);   // TMRA0趨(Ϊ 42.655ms)
			TMRA0_16bit_Start();               	 // TMRA0ʼ
		}
    }
}


/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n WDT_IRQ(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n SWI_IRQ(void)			  // SWIλжϷ
{
	SWRST = 0x5a;
	SWRST = 0xa5;
	SWRST = 0xc3;
	SWRST = 0x3c;	
}
/* -------------------  жϷ ---------------------- */


/* -------------------- SQ7653ж ------------------ */
//  [ж] Ҫжид
//  1. ʹ֮߳жж֮OnlyRetiΪӦж
//  2. ӦڵַжƣֱӸ
//
//  ʹⲿж0ӦжϱеOnlyRetiΪEXT0_IRQ
//        EXT0_IRQ,    /* 0xffd6 : EXT0_IRQ      */      //ⲿж0
//--------------------------------------------------------------//
#pragma section const INT_VECTOR1 
void * const IntTbl1[] = {
	OnlyReti,				/* 0xff3a : Reserved		  */									
	OnlyReti,				/* 0xff3c : Reserved		  */									
	OnlyReti,				/* 0xff3e : Reserved		  */									
	OnlyReti,				/* 0xff40 : Reserved		  */									
	OnlyReti,				/* 0xff42 : Reserved		  */									
	OnlyReti,				/* 0xff44 : Reserved		  */									
	OnlyReti,				/* 0xff46 : Reserved		  */								
	OnlyReti,				/* 0xff48 : Reserved		  */									
	OnlyReti,				/* 0xff4a : Reserved		  */									
	OnlyReti,				/* 0xff4c : Reserved		  */									
	OnlyReti,				/* 0xff4e : Reserved		  */									
	OnlyReti,				/* 0xff50 : Reserved		  */									
	OnlyReti,				/* 0xff52 : Reserved		  */									
	OnlyReti,				/* 0xff54 : Reserved		  */									
	OnlyReti,				/* 0xff56 : Reserved		  */									
	OnlyReti,				/* 0xff58 : Reserved		  */									
	OnlyReti,				/* 0xff5a : Reserved          */								
	OnlyReti,				/* 0xff5c : Reserved          */									
	OnlyReti,				/* 0xff5e : Reserved          */									
	OnlyReti,				/* 0xff60 : Reserved		  */									
	OnlyReti,				/* 0xff62 : Reserved		  */									
	OnlyReti,				/* 0xff64 : Reserved		  */									
	OnlyReti,				/* 0xff66 : Reserved		  */									
	OnlyReti,				/* 0xff68 : Reserved		  */									
	OnlyReti,				/* 0xff6a : Reserved    	  */
	OnlyReti,				/* 0xff6c : TX2_IRQ			  */	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : RX2_IRQ			  */	//жԴ:UART2 RX2	
	OnlyReti,				/* 0xff70 : Reserved		  */									
	OnlyReti,				/* 0xff72 : Reserved		  */									
	OnlyReti,				/* 0xff74 : Reserved		  */									
	OnlyReti,				/* 0xff76 : Reserved		  */									
	OnlyReti,				/* 0xff78 : Reserved		  */									
	OnlyReti,				/* 0xff7a : Reserved		  */									
	OnlyReti,				/* 0xff7c : Reserved		  */									
	OnlyReti,				/* 0xff7e : Reserved		  */									
	OnlyReti,				/* 0xff80 : Reserved		  */		
	OnlyReti,		    	/* 0xff82 : EXT9_IRQ		  */	//ⲿж9							
	OnlyReti,	    		/* 0xff84 : EXT8_IRQ		  */	//ⲿж8								
	OnlyReti,				/* 0xff86 : Reserved		  */									
	OnlyReti,				/* 0xff88 : Reserved		  */									
	OnlyReti,				/* 0xff8a : Reserved		  */									
	OnlyReti,				/* 0xff8c : Reserved		  */									
	OnlyReti,				/* 0xff8e : Reserved		  */									
	OnlyReti,				/* 0xff90 : TX1_IRQ		      */	//жԴ:UART1 TX1						
	OnlyReti,				/* 0xff92 : RX1_IRQ		      */	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		  */									
	OnlyReti,				/* 0xff96 : Reserved		  */									
	TMRA41_IRQ,				/* 0xff98 : TMRA41_IRQ		  */	//жԴ:Timer A4counter1								
	OnlyReti,				/* 0xff9a : TMRA40_IRQ		  */	//жԴ:Timer A4counter0								
	OnlyReti,				/* 0xff9c : TMRA31_IRQ		  */	//жԴ:Timer A3counter1								
	OnlyReti,				/* 0xff9e : TMRA30_IRQ		  */	//жԴ:Timer A3counter0								
	OnlyReti,				/* 0xffa0 : EE_IRQ			  */	//жԴ:EEPROM						
	OnlyReti,				/* 0xffa2 : EXT7_IRQ		  */	//ⲿж7						
	OnlyReti,				/* 0xffa4 : EXT6_IRQ		  */	//ⲿж6								
	OnlyReti,				/* 0xffa6 : EXT5_IRQ		  */	//ⲿж5								
	OnlyReti,				/* 0xffa8 : EXT4_IRQ		  */	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		  */									
	OnlyReti,				/* 0xffac : Reserved		  */									
	OnlyReti,				/* 0xffae : Reserved		  */									
	OnlyReti,				/* 0xffb0 : DIC_IRQ			  */	//жԴ:DIC							
	OnlyReti,				/* 0xffb2 : Reserved		  */						
	OnlyReti,				/* 0xffb4 : Reserved		  */			
	OnlyReti,				/* 0xffb6 : Reserved		  */					
	OnlyReti,				/* 0xffb8 : Reserved		  */								
	OnlyReti,				/* 0xffba : Reserved		  */									
	OnlyReti,				/* 0xffbc : Reserved		  */									
	OnlyReti,				/* 0xffbe : Reserved		  */									
	OnlyReti,				/* 0xffc0 : Reserved		  */									
	OnlyReti,				/* 0xffc2 : Reserved		  */									
	OnlyReti,				/* 0xffc4 : FMC_IRQ			  */	//жԴ:FMC								
	OnlyReti,				/* 0xffc6 : Reserved		  */					
	OnlyReti,				/* 0xffc8 : CMP_IRQ  		  */	//жԴ:Ƚ								
	OnlyReti,				/* 0xffca : Reserved		  */									
	OnlyReti,				/* 0xffcc : Reserved		  */									
	OnlyReti,			    /* 0xffce : ADC_IRQ			  */	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : EXT3_IRQ		  */	//ⲿж3								
	OnlyReti,				/* 0xffd2 : EXT2_IRQ		  */	//ⲿж2							
	OnlyReti,				/* 0xffd4 : EXT1_IRQ		  */	//ⲿж1								
	OnlyReti,				/* 0xffd6 : EXT0_IRQ		  */	//ⲿж0								
	OnlyReti,				/* 0xffd8 : SIO0_IRQ		  */	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : I2C0_IRQ		  */	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : TX0_IRQ			  */	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : RX0_IRQ			  */	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		  */									
	OnlyReti,				/* 0xffe2 : TMRA21_IRQ		  */	//жԴ:Timer A2counter1					
	OnlyReti,				/* 0xffe4 : TMRA20_IRQ		  */	//жԴ:Timer A2counter0								
	OnlyReti,				/* 0xffe6 : TMRA11_IRQ		  */	//жԴ:Timer A1counter1								
	OnlyReti,				/* 0xffe8 : TMRA10_IRQ		  */	//жԴ:Timer A1counter0
	TMRA01_IRQ,				/* 0xffea : TMRA01_IRQ		  */	//жԴ:Timer A0counter1								
	OnlyReti,				/* 0xffec : TMRA00_IRQ		  */	//жԴ:Timer A0counter0								
	OnlyReti,			    /* 0xffee : LVD1_IRQ		  */	//жԴ:͵ѹLVD1
	OnlyReti, 			    /* 0xfff0 : TBT_IRQ			  */	//жԴ:ʱTBTʱ						
	OnlyReti,				/* 0xfff2 : Reserved		  */
	OnlyReti,				/* 0xfff4 : Reserved		  */
	OnlyReti,				/* 0xfff6 : LVD0_IRQ		  */	//жԴ:͵ѹLVD0							
	WDT_IRQ,				/* 0xfff8 : WDT_IRQ			  */	//non-maskable жԴ:Źʱ	
	(void *)0xffff,			/* 0xfffa : Reserved		  */		
	SWI_IRQ,				/* 0xfffc : SWI_IRQ/INTUNDEF  */	//non-maskable		
	STARTUP					/* 0xfffe : RESET		      */	//non-maskable			
};
#pragma section const
/* ------------------- Y SQ7653ж ---------------------- */

